import { system, world } from "@minecraft/server";
import { log } from "./utils";

const WORLD = world.getDimension("overworld");

const fireworks = [
  { x: 69, y: -36, z: 1049 },
  { x: 69, y: -36, z: 1050 },
  { x: 69, y: -36, z: 1051 },
  { x: 69, y: -36, z: 1052 },
  { x: 69, y: -36, z: 1053 },
  { x: 69, y: -36, z: 1054 },
  { x: 69, y: -36, z: 1055 },
  { x: 69, y: -36, z: 1056 },
  { x: 69, y: -36, z: 1057 },
  { x: 69, y: -36, z: 1058 },
  { x: 69, y: -36, z: 1059 },
  { x: 69, y: -36, z: 1060 },
  { x: 69, y: -36, z: 1061 },
  { x: 69, y: -36, z: 1062 },
];

const fireworkSpawnLocations = [
  { x: 84, y: -10, z: 1096 },
  { x: 46, y: -30, z: 1049 },
  { x: 60, y: -20, z: 1008 },
  { x: 123, y: -22, z: 1018 },
  { x: 130, y: -20, z: 1065 },
  { x: 89, y: -11, z: 1091 },
];

const treeLightsByY = [
  {
    48: [
      { x: 83, z: 1052 },
      { x: 83, z: 1046 },
    ],
  },
  {
    45: [
      { x: 80, z: 1054 },
      { x: 80, z: 1044 },
    ],
  },
  {
    44: [
      { x: 86, z: 1055 },
      { x: 86, z: 1043 },
    ],
  },
  { 46: [{ x: 85, z: 1051 }] },
  {
    43: [
      { x: 88, z: 1052 },
      { x: 88, z: 1046 },
      { x: 88, z: 1046 },
    ],
  },
  {
    40: [
      { x: 74, z: 1046 },
      { x: 74, z: 1052 },
    ],
  },
  { 39: [{ x: 85, z: 1059 }] },
  { 41: [{ x: 91, z: 1051 }] },
  {
    35: [
      { x: 79, z: 1053 },
      { x: 79, z: 1045 },
    ],
  },
  {
    34: [
      { x: 85, z: 1055 },
      { x: 88, z: 1056 },
      { x: 88, z: 1042 },
      { x: 85, z: 1043 },
    ],
  },
  {
    33: [
      { x: 79, z: 1059 },
      { x: 79, z: 1039 },
    ],
  },
  {
    25: [
      { x: 85, z: 1042 },
      { x: 93, z: 1044 },
      { x: 85, z: 1056 },
    ],
  },
  {
    24: [
      { x: 82, z: 1038 },
      { x: 74, z: 1041 },
      { x: 76, z: 1047 },
      { x: 74, z: 1057 },
      { x: 82, z: 1058 },
    ],
  },
  { 23: [{ x: 76, z: 1051 }] },
  {
    15: [
      { x: 85, z: 1053 },
      { x: 85, z: 1045 },
    ],
  },
  {
    14: [
      { x: 78, z: 1055 },
      { x: 82, z: 1062 },
      { x: 93, z: 1058 },
      { x: 93, z: 1040 },
      { x: 82, z: 1036 },
      { x: 78, z: 1043 },
      { x: 73, z: 1040 },
      { x: 73, z: 1058 },
    ],
  },
  {
    8: [
      { x: 96, z: 1050 },
      { x: 74, z: 1038 },
      { x: 74, z: 1060 },
    ],
  },
  {
    6: [
      { x: 96, z: 1043 },
      { x: 96, z: 1055 },
    ],
  },
  {
    7: [
      { x: 91, z: 1036 },
      { x: 91, z: 1062 },
    ],
  },
  {
    5: [
      { x: 84, z: 1036 },
      { x: 72, z: 1042 },
      { x: 69, z: 1049 },
      { x: 72, z: 1056 },
      { x: 84, z: 1062 },
    ],
  },
  {
    3: [
      { x: 81, z: 1038 },
      { x: 81, z: 1060 },
    ],
  },
  {
    2: [
      { x: 73, z: 1045 },
      { x: 73, z: 1053 },
      { x: 89, z: 1056 },
      { x: 89, z: 1042 },
    ],
  },
  {
    "-6": [
      { x: 67, z: 1052 },
      { x: 95, z: 1040 },
      { x: 95, z: 1058 },
    ],
  },
  {
    "-7": [
      { x: 77, z: 1032 },
      { x: 64, z: 1044 },
      { x: 64, z: 1054 },
      { x: 77, z: 1066 },
      { x: 84, z: 1064 },
      { x: 84, z: 1034 },
    ],
  },
  { "-8": [{ x: 93, z: 1047 }] },
  {
    "-9": [
      { x: 70, z: 1035 },
      { x: 70, z: 1063 },
      { x: 90, z: 1065 },
      { x: 90, z: 1033 },
    ],
  },
  {
    "-10": [
      { x: 93, z: 1062 },
      { x: 97, z: 1056 },
      { x: 97, z: 1042 },
      { x: 93, z: 1036 },
    ],
  },
  {
    "-14": [
      { x: 61, z: 1032 },
      { x: 58, z: 1039 },
    ],
  },
  {
    "-15": [
      { x: 76, z: 1023 },
      { x: 70, z: 1034 },
      { x: 56, z: 1050 },
      { x: 61, z: 1066 },
      { x: 76, z: 1075 },
      { x: 70, z: 1064 },
    ],
  },
  {
    "-16": [
      { x: 76, z: 1032 },
      { x: 69, z: 1026 },
      { x: 69, z: 1072 },
      { x: 76, z: 1066 },
    ],
  },
  {
    "-17": [
      { x: 88, z: 1072 },
      { x: 101, z: 1051 },
      { x: 88, z: 1026 },
    ],
  },
  {
    "-18": [
      { x: 80, z: 1025 },
      { x: 63, z: 1033 },
      { x: 80, z: 1073 },
      { x: 106, z: 1043 },
      { x: 63, z: 1065 },
    ],
  },
  {
    "-19": [
      { x: 77, z: 1028 },
      { x: 77, z: 1070 },
      { x: 99, z: 1065 },
      { x: 99, z: 1033 },
    ],
  },
  {
    "-20": [
      { x: 72, z: 1036 },
      { x: 94, z: 1069 },
      { x: 90, z: 1052 },
      { x: 90, z: 1046 },
      { x: 94, z: 1029 },
      { x: 73, z: 1041 },
      { x: 73, z: 1057 },
      { x: 72, z: 1062 },
    ],
  },
  {
    "-21": [
      { x: 95, z: 1058 },
      { x: 103, z: 1055 },
      { x: 95, z: 1040 },
    ],
  },
  {
    "-22": [
      { x: 83, z: 1062 },
      { x: 83, z: 1036 },
    ],
  },
];

const festive_colors = ["red_wool", "lime_wool", "yellow_wool"];
const wool_colors = [
  "red_wool",
  "orange_wool",
  "yellow_wool",
  "lime_wool",
  "cyan_wool",
  "magenta_wool",
  "blue_wool",
  "green_wool",
  "purple_wool",
  "pink_wool",
];
const on_off_cycle = [
  "red_wool",
  "brown_wool",
  "yellow_wool",
  "brown_wool",
  "red_wool",
  "brown_wool",
  "yellow_wool",
  "brown_wool",
  "red_wool",
  "brown_wool",
];
const off_color = "brown_wool";

function randChoice(arr) {
  return arr[Math.floor(Math.random() * arr.length)];
}

export class Show {
  constructor() {
    this.showRunning = false;
    this.currentFireworks = [];
  }

  showSetup() {
    WORLD.runCommandAsync("/camera @a set podcrash:show_start");
    WORLD.runCommandAsync("/camera @a fade time 0 1 4 color 2 2 2");
    WORLD.runCommandAsync("/playsound music.carol @a ~ ~ ~ 0.1 1 1");
    WORLD.runCommandAsync("/time set 13300");
  }

  startShow() {
    if (this.showRunning) {
      return;
    }
    this.showSetup();
    this.showRunning = true;
    let showTime = 0;
    const cycleLength = 60 / 174;

    WORLD.runCommandAsync("/camera @a set podcrash:tree_up ease 12 in_sine");
    for (let j = 0; j <= 19; j++) {
      for (let i = 0; i < wool_colors.length; i++) {
        system.runTimeout(() => {
          if (!this.showRunning) {
            return;
          } else {
            if (i == 0) {
              if (j == 19) {
                WORLD.runCommandAsync("/camera @a fade time 2 2 2 color 2 2 2");
              }
              if (j == 16) {
                WORLD.runCommandAsync(
                  "/camera @a set podcrash:tree_up ease 6 out_bounce"
                );
              }
              if (j == 13) {
                WORLD.runCommandAsync(
                  "/camera @a set podcrash:tree5 ease 6 out_quad"
                );
              }
              if (j == 10) {
                WORLD.runCommandAsync(
                  "/camera @a set podcrash:tree4 ease 8 out_quad"
                );
              }
              if (j == 8) {
                WORLD.runCommandAsync(
                  "/camera @a set podcrash:tree3 ease 8 out_quad"
                );
              }
              if (j == 4) {
                WORLD.runCommandAsync(
                  "/camera @a set podcrash:tree2 ease 12 out_cubic"
                );
              }
            }

            if (j > 9) {
              this.fillLights(wool_colors, cycleLength);
            } else if (j > 3) {
              this.fillLights(festive_colors, cycleLength * 2);
            } else {
              this.fillLights(wool_colors[i], cycleLength);
            }
            if (i % 2 == 0) {
              if (j > 2) {
                fireworkSpawnLocations.forEach((loc) => {
                  if (!this.currentFireworks.includes(loc)) {
                    this.createFirework(randChoice(fireworks), loc);
                  }
                });
              }

              WORLD.spawnParticle("podcrash:tree_top", {
                x: 82,
                y: 61,
                z: 1049,
              }); 
              WORLD.spawnParticle("podcrash:snow", { x: 82, y: 66, z: 1049 });
              WORLD.spawnParticle("podcrash:snow", { x: 82, y: 44, z: 1049 });
              WORLD.spawnParticle("podcrash:snow", { x: 82, y: 22, z: 1049 });

              WORLD.spawnParticle("podcrash:swirl", { x: 79, y: -12, z: 1027 });
              WORLD.spawnParticle("podcrash:swirl", {
                x: 104,
                y: -11,
                z: 1049,
              });
              WORLD.spawnParticle("podcrash:swirl", { x: 80, y: -12, z: 1071 });
              WORLD.spawnParticle("podcrash:swirl", { x: 59, y: -11, z: 1049 });
            }
            WORLD.spawnParticle("podcrash:sparkle", { x: 80, y: -11, z: 1049 });
          }
        }, showTime * 20);
        showTime += cycleLength;
      }
    }
    system.runTimeout(() => this.stopShow(), showTime * 20);
  }

  stopShow() {
    this.showRunning = false;
    WORLD.runCommandAsync("/camera @a clear");
    WORLD.runCommandAsync("/stopsound @a music.carol");
    WORLD.runCommandAsync("/time set 12500");
    this.currentFireworks.forEach((loc) => {
      WORLD.runCommandAsync(
        `fill ${loc.x} ${loc.y - 1} ${loc.z} ${loc.x} ${loc.y} ${loc.z} air`
      );
    });
  }

  createFirework(randFirework, randFireworkLoc, cycles = 3) {
    this.currentFireworks.push(randFireworkLoc);
    WORLD.runCommandAsync(
      `clone ${randFirework.x} ${randFirework.y} ${randFirework.z} ${randFirework.x} ${randFirework.y} ${randFirework.z} ${randFireworkLoc.x} ${randFireworkLoc.y} ${randFireworkLoc.z}`
    );
    log(`created firework at ${randFireworkLoc}`);

    let on = false;
    for (let i = 1; i <= cycles + 1; i++) {
      system.runTimeout(() => {
        if (i == cycles + 1) {
          WORLD.runCommandAsync(
            `fill ${randFireworkLoc.x} ${randFireworkLoc.y - 1} ${
              randFireworkLoc.z
            } ${randFireworkLoc.x} ${randFireworkLoc.y} ${
              randFireworkLoc.z
            } air`
          );
          this.currentFireworks = this.currentFireworks.filter(
            (v) => v != randFireworkLoc
          );
        } else {
          if (on) {
            WORLD.runCommandAsync(
              `setblock ${randFireworkLoc.x} ${randFireworkLoc.y - 1} ${
                randFireworkLoc.z
              } air`
            );
            on = false;
          } else {
            WORLD.runCommandAsync(
              `setblock ${randFireworkLoc.x} ${randFireworkLoc.y - 1} ${
                randFireworkLoc.z
              } redstone_block`
            );
            on = true;
          }
        }
      }, 20 * i);
    }
  }

  fillLights(block = "red_wool", overTime = 2) {
    const rowsPerTime = overTime / treeLightsByY.length;

    let rowI = 0;
    for (let i = treeLightsByY.length - 1; i >= 0; i--) {
      let y = Object.keys(treeLightsByY[i])[0];
      let sameHeight = treeLightsByY[i][y];

      sameHeight.forEach((xz) => {
        let x = xz.x;
        let z = xz.z;

        system.runTimeout(() => {
          if (typeof block == "string") {
            WORLD.runCommandAsync(`setblock ${x} ${y} ${z} ${block}`);
          } else {
            WORLD.runCommandAsync(
              `setblock ${x} ${y} ${z} ${randChoice(block)}`
            );
          }
        }, rowsPerTime * rowI * 20);
      });

      rowI++;
    }
  }
}
