import { world } from "@minecraft/server";
import { log } from "./utils";

export function rewardPlayer(player, board_name, rate) {
    let board = world.scoreboard.getObjective(board_name);
    giveCandy(player, Math.max(0, board.getScore(player) / rate | 0)+"");
    board.setScore(player, 0);
}

export function giveCandy(player, amountString) {
    if (amountString == null || isNaN(amountString.replace('-',''))) return;
    var amt;
    if (amountString.includes('-') && !amountString.startsWith('-')) {
        var min = Number(amountString.split('-')[0]);
        var max = Number(amountString.split('-')[1]);
        amt = min + (Math.random() * (max - min) | 0);
    } else {
        amt = Number(amountString);
    }
    if(amt==0) return;
    world.scoreboard.getObjective("candy").addScore(player, amt);
    player.runCommand(`/titleraw @s actionbar { "rawtext": [ { "text": "§a+${amt} §f\uE10A" } ] }`);

}