import { ActionFormData } from "@minecraft/server-ui";
import { getDistance } from "./utils";

const destinations = new Map();
const locations = new Map();
locations.set("Townhall", {x: -24, y: -33, z: 1049});
locations.set("Library", {x: 19, y: -32, z: 1009});
locations.set("Stables", {x: -18, y: -33, z: 937});
locations.set("Thomas' Tool Shop", {x: 45, y: -32, z: 977});
locations.set("Jake's Furniture Shop", {x: 96, y: -30, z: 1081});
locations.set("Dave's Furniture Shop", {x: -27, y: -32, z: 1103});
locations.set("Bob's Tree Logging", {x: -21, y: -27, z: 730});
locations.set("Ben's Fisher Hut", {x: 271, y: -35, z: 761});
locations.set("Santa's Workshop", {x: 677, y: -20, z: 442});
locations.set("Snowball Fight", {x: 460, y: -37, z: 1023});
locations.set("Snowball Range", {x: -137, y: -29, z: 480});

export function showMenu(player) {
    const form = new ActionFormData();
    form.title("Navigation");
    form.body("Select your Destination, then track it using your Navigation Compass!");
    locations.forEach((v, k) => {
        form.button(`${k} (${Math.floor(getDistance(v, player.location))} blocks away)`);
    });

    form.show(player).then((r) => {
        if(r.canceled) return;
        var i=0;
        locations.forEach((v, k) => {
            if(i==r.selection) {
                destinations.set(player.name, k);
                player.runCommand(`tellraw @s { "rawtext": [ { "text": "§aNow Tracking: §f${k}" } ] }`);
            }
            i++;
        });
    });
}

export function displayText(player) {
    if(destinations.has(player.name)) {
        player.runCommand(`titleraw @s actionbar { "rawtext": [ { "text": "§g${destinations.get(player.name)} §6| §g${Math.floor(getDistance(player.location, locations.get(destinations.get(player.name))))} blocks away" } ] }`);
    } else {
        player.runCommand(`titleraw @s actionbar { "rawtext": [ { "text": "§cClick the Navigation Compass to select a Destination!" } ] }`);
    }
}