import { world } from "@minecraft/server";
import { log } from "../utils";
import Shop from "./Shop";

export function openToolsShop(player) {
    const shop = new Shop(player, "Tools", "Purchase your favorite tools here!");
    if (world.scoreboard.getObjective("snow_shovel").getScore(player) == 0) {
        shop.addElement(30, "\uE10B §rSnow Shovel", () => {
            world.scoreboard.getObjective("snow_shovel").setScore(player, 1);
            player.runCommand(`/tellraw @s { "rawtext": [ { "text": "§7[§q§lElf§r§7] §fI will store your §gSnow Shovel§f for you until you need it!" } ] }`)
        });
    }
    if (world.scoreboard.getObjective("axe").getScore(player) == 0) {
        shop.addElement(30, "\uE10C §rAxe", () => {
            world.scoreboard.getObjective("axe").setScore(player, 1);
            player.runCommand(`/tellraw @s { "rawtext": [ { "text": "§7[§q§lElf§r§7] §fI will store your §gAxe§f for you until you need it!" } ] }`)
        });
    }
    shop.open();
}

export function openHorseShop(player) {
    const shop = new Shop(player, "Horses", "Purchase a Horse and ride with it around the Map! The Horse allows for quicker travelling.");
    if (world.scoreboard.getObjective("horse").getScore(player) == 0) {
        shop.addElement(100, "\uE10D §rHorse", () => {
            world.scoreboard.getObjective("horse").setScore(player, 1);
            player.runCommand(`/tellraw @s { "rawtext": [ { "text": "§7[§q§lElf§r§7] §fSpawn your §pHorse§f using the Horse Item in your Inventory at any time!" } ] }`)
        });
    }
    shop.open();
}

export function openFurnitureShop1(player) {
    if (!player.hasTag("editing_furniture")) {
        player.runCommand(`tellraw @s { "rawtext": [ { "translate": "feature.shop.not_in_furniture_mode" } ] }`);
        return;
    }
    const shop = new Shop(player, "Furniture", "In this Shop, you can purchase Furniture in Oak and Dark Oak looks!");
    shop.addElement(8, "\uE10E §rOak Chair", () => {
        player.runCommand("/give @s podcrash:oak_chair_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.addElement(8, "\uE118 §rDark Oak Chair", () => {
        player.runCommand("/give @s podcrash:dark_oak_chair_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.addElement(6, "\uE10F §rOak Stool", () => {
        player.runCommand("/give @s podcrash:oak_stool_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.addElement(6, "\uE119 §rDark Oak Stool", () => {
        player.runCommand("/give @s podcrash:dark_oak_stool_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.addElement(20, "\uE110 §rOak Table", () => {
        player.runCommand("/give @s podcrash:oak_table_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.addElement(20, "\uE11A §rDark Oak Table", () => {
        player.runCommand("/give @s podcrash:dark_oak_table_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.addElement(15, "\uE111 §rOak Coffee Table", () => {
        player.runCommand("/give @s podcrash:oak_coffee_table_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.addElement(15, "\uE11B §rDark Oak Coffee Table", () => {
        player.runCommand("/give @s podcrash:dark_oak_coffee_table_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.addElement(10, "\uE112 §rOak Shelf", () => {
        player.runCommand("/give @s podcrash:oak_shelf_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.addElement(10, "\uE11C §rDark Oak Shelf", () => {
        player.runCommand("/give @s podcrash:dark_oak_shelf_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.addElement(150, "\uE122 §rFireplace", () => {
        player.runCommand("/give @s podcrash:fireplace_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.addElement(100, "\uE127 §rKitchen Unit", () => {
        player.runCommand("/give @s podcrash:kitchen_unit_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.addElement(40, "\uE12A §rRed Sofa Chair", () => {
        player.runCommand("/give @s podcrash:red_sofa_chair_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.addElement(40, "\uE12B §rGreen Sofa Chair", () => {
        player.runCommand("/give @s podcrash:green_sofa_chair_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.addElement(40, "\uE12C §rWhite Sofa Chair", () => {
        player.runCommand("/give @s podcrash:white_sofa_chair_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.addElement(60, "\uE12D §rRed Sofa", () => {
        player.runCommand("/give @s podcrash:red_sofa_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.addElement(60, "\uE12E §rGreen Sofa", () => {
        player.runCommand("/give @s podcrash:green_sofa_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.addElement(60, "\uE12F §rWhite Sofa", () => {
        player.runCommand("/give @s podcrash:white_sofa_spawn_egg");
        openFurnitureShop1(player);
    });
    shop.open();
}

export function openFestiveBoxShop(player) {
    if (!player.hasTag("editing_furniture")) {
        player.runCommand(`tellraw @s { "rawtext": [ { "translate": "feature.shop.not_in_furniture_mode" } ] }`);
        return;
    }
    const shop = new Shop(player, "Festive Boxes", "In this Shop, you can purchase Festive Boxes!");
    shop.addElement(6, "\uE126 §rFestive Box", () => {
        player.runCommand("/give @s podcrash:red_green_festive_box_spawn_egg");
        openFestiveBoxShop(player);
    });
    shop.addElement(6, "\uE125 §rFestive Box", () => {
        player.runCommand("/give @s podcrash:red_yellow_festive_box_spawn_egg");
        openFestiveBoxShop(player);
    });
    shop.addElement(6, "\uE124 §rFestive Box", () => {
        player.runCommand("/give @s podcrash:green_red_festive_box_spawn_egg");
        openFestiveBoxShop(player);
    });
    shop.addElement(6, "\uE123 §rFestive Box", () => {
        player.runCommand("/give @s podcrash:green_yellow_festive_box_spawn_egg");
        openFestiveBoxShop(player);
    });

    shop.open();
}

export function openFestiveTreeShop(player) {
    if (!player.hasTag("editing_furniture")) {
        player.runCommand(`tellraw @s { "rawtext": [ { "translate": "feature.shop.not_in_furniture_mode" } ] }`);
        return;
    }
    const shop = new Shop(player, "Festive Trees", "In this Shop, you can purchase Festive Trees!");
    shop.addElement(15, "\uE128 §rFestive Tree", () => {
        player.runCommand("/give @s podcrash:festive_tree_spawn_egg");
        openFestiveTreeShop(player);
    });
    shop.addElement(20, "\uE129 §rFestive Tree With           Lights", () => {
        player.runCommand("/give @s podcrash:festive_tree_with_lights_spawn_egg");
        openFestiveTreeShop(player);
    });
    shop.open();
}

export function openDecorationShop1(player) {
    if (!player.hasTag("editing_furniture")) {
        player.runCommand(`tellraw @s { "rawtext": [ { "translate": "feature.shop.not_in_furniture_mode" } ] }`);
        return;
    }
    const shop = new Shop(player, "Decoration", "In this Shop, you can purchase various Festive Decoration!");
    shop.addElement(8, "\uE132 §rFestive Lights", () => {
        player.runCommand("/give @s podcrash:festive_lights_spawn_egg");
        openDecorationShop1(player);
    });
    shop.addElement(4, "\uE133 §rFestive Wreath", () => {
        player.runCommand("/give @s podcrash:festive_wreath_spawn_egg");
        openDecorationShop1(player);
    });
    shop.addElement(6, "\uE130 §rCandy Cane", () => {
        player.runCommand("/give @s podcrash:candy_cane_spawn_egg");
        openDecorationShop1(player);
    });
    shop.open();
}

export function openDecorationShop2(player) {
    if (!player.hasTag("editing_furniture")) {
        player.runCommand(`tellraw @s { "rawtext": [ { "translate": "feature.shop.not_in_furniture_mode" } ] }`);
        return;
    }
    const shop = new Shop(player, "Decoration", "In this Shop, you can purchase various Festive Decoration!");
    shop.addElement(8, "\uE131 §rFestive Garland", () => {
        player.runCommand("/give @s podcrash:festive_garland_spawn_egg");
        openDecorationShop2(player);
    });
    shop.addElement(4, "\uE134 §rHolly", () => {
        player.runCommand("/give @s podcrash:holly_spawn_egg");
        openDecorationShop2(player);
    });
    shop.addElement(4, "\uE135 §rMistle Toe", () => {
        player.runCommand("/give @s podcrash:mistle_toe_spawn_egg");
        openDecorationShop2(player);
    });
    shop.open();
}


export function openFurnitureShop2(player) {
    if (!player.hasTag("editing_furniture")) {
        player.runCommand(`tellraw @s { "rawtext": [ { "translate": "feature.shop.not_in_furniture_mode" } ] }`);
        return;
    }
    const shop = new Shop(player, "Furniture", "In this Shop, you can purchase Furniture in Spruce and Mangrove looks!");
    shop.addElement(8, "\uE113 §rSpruce Chair", () => {
        player.runCommand("/give @s podcrash:spruce_chair_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.addElement(8, "\uE11D §rMangrove Chair", () => {
        player.runCommand("/give @s podcrash:mangrove_chair_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.addElement(6, "\uE114 §rSpruce Stool", () => {
        player.runCommand("/give @s podcrash:spruce_stool_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.addElement(6, "\uE11E §rMangrove Stool", () => {
        player.runCommand("/give @s podcrash:mangrove_stool_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.addElement(20, "\uE115 §rSpruce Table", () => {
        player.runCommand("/give @s podcrash:spruce_table_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.addElement(20, "\uE11F §rMangrove Table", () => {
        player.runCommand("/give @s podcrash:mangrove_table_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.addElement(15, "\uE116 §rSpruce Coffee Table", () => {
        player.runCommand("/give @s podcrash:spruce_coffee_table_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.addElement(15, "\uE120 §rMangrove Coffee Table", () => {
        player.runCommand("/give @s podcrash:mangrove_coffee_table_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.addElement(10, "\uE117 §rSpruce Shelf", () => {
        player.runCommand("/give @s podcrash:spruce_shelf_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.addElement(10, "\uE121 §rMangrove Shelf", () => {
        player.runCommand("/give @s podcrash:mangrove_shelf_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.addElement(150, "\uE122 §rFireplace", () => {
        player.runCommand("/give @s podcrash:fireplace_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.addElement(100, "\uE127 §rKitchen Unit", () => {
        player.runCommand("/give @s podcrash:kitchen_unit_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.addElement(40, "\uE12A §rRed Sofa Chair", () => {
        player.runCommand("/give @s podcrash:red_sofa_chair_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.addElement(40, "\uE12B §rGreen Sofa Chair", () => {
        player.runCommand("/give @s podcrash:green_sofa_chair_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.addElement(40, "\uE12C §rWhite Sofa Chair", () => {
        player.runCommand("/give @s podcrash:white_sofa_chair_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.addElement(60, "\uE12D §rRed Sofa", () => {
        player.runCommand("/give @s podcrash:red_sofa_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.addElement(60, "\uE12E §rGreen Sofa", () => {
        player.runCommand("/give @s podcrash:green_sofa_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.addElement(60, "\uE12F §rWhite Sofa", () => {
        player.runCommand("/give @s podcrash:white_sofa_spawn_egg");
        openFurnitureShop2(player);
    });
    shop.open();
}